set echo off
set feedback off
set termout off
create table sport_results
(position  number(3)    not null
,name     varchar2(30) not null
,duration     date         not null
)
/
insert into sport_results values (1,'David Zabriskie (USA)',trunc(sysdate) + 0/24 + 58/24/60 + 31/24/60/60);
insert into sport_results values (2,'Ivan Basso (ITA)',trunc(sysdate) + 0/24 + 58/24/60 + 48/24/60/60);
insert into sport_results values (3,'Paolo Savoldelli (ITA)',trunc(sysdate) + 0/24 + 59/24/60 + 15/24/60/60);
insert into sport_results values (4,'Marzio Bruseghin (ITA)',trunc(sysdate) + 0/24 + 59/24/60 + 19/24/60/60);
insert into sport_results values (5,'Serguei Gonchar (UKR)',trunc(sysdate) + 0/24 + 59/24/60 + 19/24/60/60);
insert into sport_results values (6,'Vladimir Karpets (RUS)',trunc(sysdate) + 0/24 + 59/24/60 + 38/24/60/60);
insert into sport_results values (7,'Markus Fothen (GER)',trunc(sysdate) + 0/24 + 59/24/60 + 46/24/60/60);
insert into sport_results values (8,'Thomas Dekker (NLD)',trunc(sysdate) + 0/24 + 59/24/60 + 54/24/60/60);
insert into sport_results values (9,'Jan Hruska (CZE)',trunc(sysdate) + 1/24 + 0/24/60 + 5/24/60/60);
insert into sport_results values (10,'Danilo di Luca (ITA)',trunc(sysdate) + 1/24 + 0/24/60 + 5/24/60/60);

commit
/
set echo on
set termout on
set feedback on
clear screen
select position,name,to_char(duration,'hh24:mi:ss') duration from sport_results order by position
/

pause
set echo off
clear screen
select position
     , name
     , decode
       ( position
       , 1, to_char(duration,'fmhh24fm:mi:ss')
       , case lag(duration) over (order by position)
         when duration then '   s.t.'
         else '+' || lpad
           (to_char
             ( trunc(sysdate) +
               (duration - first_value(duration) over (order by position))
             , 'fmmifm:ss'
             )
           ,6
           )
         end
       ) duration
  from sport_results
 order by position
/

pause
set echo on
clear screen
set autotrace on explain

select position
     , name
     , decode
       ( position
       , 1, to_char(duration,'fmhh24fm:mi:ss')
       , case lag(duration) over (order by position)
         when duration then '   s.t.'
         else '+' || lpad
           (to_char
             ( trunc(sysdate) +
               (duration - first_value(duration) over (order by position))
             , 'fmmifm:ss'
             )
           ,6
           )
         end
       ) duration
  from sport_results
 order by position
/
pause
set autotrace off
drop table sport_results purge
/
