set echo on
clear screen
create table a (id)
as
select 1 from dual union all
select 2 from dual
/
create table b (id)
as
select 2 from dual union all
select 3 from dual
/
exec dbms_stats.gather_table_stats(user,'a')
exec dbms_stats.gather_table_stats(user,'b')
pause
set autotrace on explain
select /*+ no_native_full_outer_join */
       a.id
     , b.id
  from a
       full outer join b on a.id = b.id
/
pause
select a_id
     , b_id
  from ( select a.id a_id
              , b.id b_id
           from a
              , b
          where a.id = b.id (+)
          union all
         select null
              , b.id
           from b
          where not exists
                ( select null
                    from a
                   where a.id = b.id
                )
       )
/
pause
select /*+ native_full_outer_join */
       a.id
     , b.id
  from a
       full outer join b on a.id = b.id
/
pause
select a.id
     , b.id
  from a
       full outer join b on a.id = b.id
/
set autotrace off
set echo off
drop table a purge
/
drop table b purge
/
