set echo on
column enames format a40
clear screen
select deptno
     , ename
  from emp
 order by deptno
     , ename
/
remark
remark
remark  String aggregation
remark
remark  Produce the following output:
remark
remark  DEPTNO     ENAMES
remark  ---------- ----------------------------------------
remark
remark  10         CLARK,KING,MILLER
remark  20         SMITH,FORD,ADAMS,SCOTT,JONES
remark  30         ALLEN,BLAKE,MARTIN,TURNER,JAMES,WARD
remark
remark
pause
clear screen
remark
remark   H i e r a r c h i c a l   q u e r y
remark
select deptno
     , ename
     , row_number() over (partition by deptno order by ename) rn
  from emp
/
pause
 select deptno
      , sys_connect_by_path(ename, ',' ) enames
   from ( select deptno
               , ename
               , row_number() over (partition by deptno order by ename) rn
            from emp
        )
  start with rn = 1
connect by prior rn = rn-1
    and prior deptno = deptno
  order by deptno
      , enames
/
pause
 select deptno
      , substr(max(sys_connect_by_path(ename, ',' )),2) enames
   from ( select deptno
               , ename
               , row_number() over (partition by deptno order by ename) rn
            from emp
        )
  start with rn = 1
connect by prior rn = rn-1
    and prior deptno = deptno
  group by deptno
  order by deptno
/
pause
clear screen
remark
remark   M o d e l   c l a u s e
remark
select deptno
     , ename
     , rn
  from emp
 model
       partition by (deptno)
       dimension by (row_number() over (partition by deptno order by ename) rn)
       measures     (cast(ename as varchar2(40)) ename)
       rules
       ( ename[any] order by rn desc = ename[cv()]||','||ename[cv()+1]
       )
 order by deptno
     , rn
/
pause
select deptno
     , rtrim(ename,',') enames
  from ( select deptno
              , ename
              , rn
           from emp
          model
                partition by (deptno)
                dimension by (row_number() over (partition by deptno order by ename) rn)
                measures     (cast(ename as varchar2(40)) ename)
                rules
                ( ename[any] order by rn desc = ename[cv()]||','||ename[cv()+1]
                )
       )
 where rn = 1
 order by deptno
/
pause
clear screen
/* Commented out because of weird OCI-21522 errors and losing the connection
remark
remark   C o l l e c t
remark
column collectie format a100
create type varchar2_tt as table of varchar2(40);
/
create function to_string (p_varchar2_tt in varchar2_tt) return varchar2
is
  l_string varchar2(32767);
  i number;
begin
  i := p_varchar2_tt.first;
  while i is not null
  loop
    l_string := l_string || ',' || p_varchar2_tt(i);
    i := p_varchar2_tt.next(i);
  end loop
  ;
  return ltrim(l_string,',');
end to_string;
/
pause
select deptno
     , collect(ename) collectie
  from emp
 group by deptno
 order by deptno
/
pause
select deptno
     , cast(collect(ename) as varchar2_tt) collectie
  from emp
 group by deptno
 order by deptno
/
pause
select deptno
     , to_string(cast(collect(ename) as varchar2_tt)) enames
  from emp
 group by deptno
 order by deptno
/
pause
drop type varchar2_tt
/
drop function to_string
/
*/
clear screen
remark
remark   X M L
remark
column x format a100
select deptno
     , xmlelement("X",ename || ',') x
  from emp
 order by deptno
     , ename
/
pause
select deptno
     , xmlagg(xmlelement("X",ename || ',')) x
  from emp
 group by deptno
 order by deptno
/
pause
select deptno
     , extract(xmlagg(xmlelement("X",ename || ',')), '/X/text()') enames
  from emp
 group by deptno
 order by deptno
/
pause
select deptno
     , rtrim(extract(xmlagg(xmlelement("X",ename || ',')), '/X/text()'),',') enames
  from emp
 group by deptno
 order by deptno
/
clear screen
remark
remark  R e c u r s i v e   S u b q u e r y   F a c t o r i n g
remark
with t (deptno,ename,enames) as
( 

clear screen
remark
remark  L I S T A G G
remark
select deptno
     , listagg(ename,',') within group (order by ename) enames
  from emp
 group by deptno
 order by deptno
/
set echo off
