set echo on
clear screen
create table booksales
( book    varchar2(17)
, month   date
, country varchar2(3)
, amount  number(6,0)
, primary key (book,month,country)
)
/
insert into booksales values ('The Da Vinci Code',to_date('01032005','ddmmyyyy'),'NED',5);
insert into booksales values ('The Da Vinci Code',to_date('01042005','ddmmyyyy'),'NED',8);
insert into booksales values ('The Da Vinci Code',to_date('01052005','ddmmyyyy'),'NED',3);
insert into booksales values ('The Da Vinci Code',to_date('01072005','ddmmyyyy'),'NED',2);
insert into booksales values ('The Da Vinci Code',to_date('01102005','ddmmyyyy'),'NED',1);
insert into booksales values ('The Da Vinci Code',to_date('01022005','ddmmyyyy'),'GBR',15);
insert into booksales values ('The Da Vinci Code',to_date('01032005','ddmmyyyy'),'GBR',33);
insert into booksales values ('The Da Vinci Code',to_date('01042005','ddmmyyyy'),'GBR',47);
insert into booksales values ('The Da Vinci Code',to_date('01052005','ddmmyyyy'),'GBR',44);
insert into booksales values ('The Da Vinci Code',to_date('01062005','ddmmyyyy'),'GBR',11);
insert into booksales values ('The Da Vinci Code',to_date('01082005','ddmmyyyy'),'GBR',2);
insert into booksales values ('The Da Vinci Code',to_date('01052005','ddmmyyyy'),'FRA',2);
insert into booksales values ('The Da Vinci Code',to_date('01082005','ddmmyyyy'),'FRA',3);
insert into booksales values ('The Da Vinci Code',to_date('01012006','ddmmyyyy'),'FRA',4);
insert into booksales values ('Lord Of The Rings',to_date('01012005','ddmmyyyy'),'NED',102);
insert into booksales values ('Lord Of The Rings',to_date('01022005','ddmmyyyy'),'NED',55);
insert into booksales values ('Lord Of The Rings',to_date('01032005','ddmmyyyy'),'NED',68);
insert into booksales values ('Lord Of The Rings',to_date('01042005','ddmmyyyy'),'NED',42);
insert into booksales values ('Lord Of The Rings',to_date('01052005','ddmmyyyy'),'NED',87);
insert into booksales values ('Lord Of The Rings',to_date('01062005','ddmmyyyy'),'NED',40);
insert into booksales values ('Lord Of The Rings',to_date('01072005','ddmmyyyy'),'NED',31);
insert into booksales values ('Lord Of The Rings',to_date('01082005','ddmmyyyy'),'NED',26);
insert into booksales values ('Lord Of The Rings',to_date('01092005','ddmmyyyy'),'NED',22);
insert into booksales values ('Lord Of The Rings',to_date('01102005','ddmmyyyy'),'NED',23);
insert into booksales values ('Lord Of The Rings',to_date('01112005','ddmmyyyy'),'NED',88);
insert into booksales values ('Lord Of The Rings',to_date('01122005','ddmmyyyy'),'NED',143);
insert into booksales values ('Lord Of The Rings',to_date('01012006','ddmmyyyy'),'NED',31);
insert into booksales values ('Lord Of The Rings',to_date('01022006','ddmmyyyy'),'NED',18);
insert into booksales values ('Lord Of The Rings',to_date('01032006','ddmmyyyy'),'NED',15);
insert into booksales values ('Lord Of The Rings',to_date('01042006','ddmmyyyy'),'NED',11);
insert into booksales values ('Lord Of The Rings',to_date('01052006','ddmmyyyy'),'NED',17);
insert into booksales values ('Lord Of The Rings',to_date('01062006','ddmmyyyy'),'NED',9);
insert into booksales values ('Lord Of The Rings',to_date('01072006','ddmmyyyy'),'NED',12);
insert into booksales values ('Lord Of The Rings',to_date('01082006','ddmmyyyy'),'NED',20);
insert into booksales values ('Lord Of The Rings',to_date('01092006','ddmmyyyy'),'NED',4);
insert into booksales values ('Lord Of The Rings',to_date('01102006','ddmmyyyy'),'NED',5);
insert into booksales values ('Lord Of The Rings',to_date('01112006','ddmmyyyy'),'NED',1);
insert into booksales values ('Lord Of The Rings',to_date('01122006','ddmmyyyy'),'NED',1);
alter session set nls_date_format = 'mm-yyyy';
clear screen
select month
     , amount
  from booksales
 where book = 'The Da Vinci Code'
   and country = 'FRA'
/
pause
select month
  from dual
 model
       reference min_max on
                 ( select 1 rn
                        , min(month) min_month
                        , max(month) max_month
                     from booksales
                    where book = 'The Da Vinci Code'
                      and country = 'FRA'
                 )
                 dimension by (rn)
                 measures (min_month, max_month)
       main resultaat
       dimension by (1 x)
       measures (sysdate month)
       rules
       ( month[for x from 0 to months_between(max_month[1],min_month[1]) increment 1] = add_months(min_month[1],cv(x))
       )
 order by month
/
pause
remark
remark  Simulating a partitioned outer join
remark
select book
     , to_date(to_char(trunc((monthnummer-1)/12)) || to_char(nvl(nullif(mod(monthnummer,12),0),12)), 'yyyymm') month
     , country
     , amount
  from booksales
 where book = 'The Da Vinci Code'
   and country = 'FRA'
 model
       reference min_max on
                 ( select 1 rn
                        , min(to_number(to_char(month,'yyyy'))*12+to_number(to_char(month,'mm'))) min_monthnummer
                        , max(to_number(to_char(month,'yyyy'))*12+to_number(to_char(month,'mm'))) max_monthnummer
                     from booksales
                    where book = 'The Da Vinci Code'
                      and country = 'FRA'
                 )
                 dimension by (rn)
                 measures (min_monthnummer, max_monthnummer)
       main resultaat
       partition by (country,book)
       dimension by (to_number(to_char(month,'yyyy'))*12+to_number(to_char(month,'mm')) monthnummer)
       measures (amount)
       rules
       ( amount[for monthnummer from min_monthnummer[1] to max_monthnummer[1] increment 1] = nvl(amount[cv()],0)
       )
 order by monthnummer
/

set echo off
drop table booksales purge
/
