set echo on
create table t
as
select 1 id, 1 nr from dual union all
select 2, null from dual
/
select id
     , nr
     , text
  from t
 model
       dimension by (id)
       measures (nr,cast(null as varchar2(20)) text)
       rules
       ( text[3] = case
                    when nr[0] is present then 'IS PRESENT'
                    else 'IS NOT PRESENT'
                    end
       , text[4] = case
                    when nr[0] is null then 'IS NULL'
                    else 'IS NOT NULL'
                    end
       , text[5] = presentv(nr[0],'PRESENTV','NOT PRESENTV')
       , text[6] = presentv(nr[1],'PRESENTV','NOT PRESENTV')
       , text[7] = presentv(nr[2],'PRESENTV','NOT PRESENTV')
       , text[8] = presentnnv(nr[0],'PRESENTNNV','NOT PRESENTNNV')
       , text[9] = presentnnv(nr[1],'PRESENTNNV','NOT PRESENTNNV')
       , text[10] = presentnnv(nr[2],'PRESENTNNV','NOT PRESENTNNV')
       )
 order by id
/
set echo off
drop table t purge
/
