set echo on
column department format a15
clear screen
remark
remark  From Mark Rittman's article: Using The SQL MODEL Clause To Generate Financial Statements
remark  http://www.rittmanmead.com/files/sql_model_clause.html
remark
create table financial_statement
( rep_line_id   number
, rep_line_item varchar2(30)
, department    varchar2(30)
, actual        number(10,2)
, budget        number(10,2)
, variance      number(10,2)
)
/
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 1, 'Net Sales', 'Retail', 5000, 5500, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 2, 'Gross Profit', 'Retail', 4000, 4750, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 3, 'Other Income', 'Retail', 900, 0, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 4, 'Total Net Income', 'Retail', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 5, 'Wage Costs', 'Retail', 3500, 3400, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 6, 'Rent Costs', 'Retail', 750, 750, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 7, 'Other Costs', 'Retail', 200, 0, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 8, 'Total Costs', 'Retail', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 9, 'Net Contribution', 'Retail', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 1, 'Net Sales', 'Direct', 3000, 2800, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 2, 'Gross Profit', 'Direct', 2250, 2000, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 3, 'Other Income', 'Direct', 0, 0, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 4, 'Total Net Income', 'Direct', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 5, 'Wage Costs', 'Direct', 1000, 1100, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 6, 'Rent Costs', 'Direct', 800, 700, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 7, 'Other Costs', 'Direct', 50, 35, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 8, 'Total Costs', 'Direct', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 9, 'Net Contribution', 'Direct', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 1, 'Net Sales', 'Internet', 2000, 4000, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 2, 'Gross Profit', 'Internet', 1500, 3000, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 3, 'Other Income', 'Internet', 300, 100, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 4, 'Total Net Income', 'Internet', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 5, 'Wage Costs', 'Internet', 1000, 1100, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 6, 'Rent Costs', 'Internet', 800, 500, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 7, 'Other Costs', 'Internet', 100, 0, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 8, 'Total Costs', 'Internet', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 9, 'Net Contribution', 'Internet', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 10, 'Gross Profit % of Net Sales', 'Retail', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 11, 'Wages % of Net Sales', 'Retail', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 12, 'Total Costs % of Net Sales', 'Retail', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 13, 'Net Contrib. % of Net Sales', 'Retail', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 10, 'Gross Profit % of Net Sales', 'Direct', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 11, 'Wages % of Net Sales', 'Direct', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 12, 'Total Costs % of Net Sales', 'Direct', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 13, 'Net Contrib. % of Net Sales', 'Direct', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 10, 'Gross Profit % of Net Sales', 'Internet', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 11, 'Wages % of Net Sales', 'Internet', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 12, 'Total Costs % of Net Sales', 'Internet', NULL, NULL, NULL); 
INSERT INTO FINANCIAL_STATEMENT ( REP_LINE_ID, REP_LINE_ITEM, DEPARTMENT, ACTUAL, BUDGET, VARIANCE ) 
VALUES ( 13, 'Net Contrib. % of Net Sales', 'Internet', NULL, NULL, NULL); 

select *
  from financial_statement
 order by department
     , rep_line_id
/
pause
select rep_line_id
     , rep_line_item
     , department
     , actual
     , budget
     , variance
  from financial_statement
 model
     dimension by (rep_line_id, department)
     measures (rep_line_item, actual, budget, variance)
     rules upsert
     ( actual [4,department] = actual[2,cv(department)] + actual [3,cv(department)]
     , budget [4,department] = budget[2,cv(department)] + budget [3,cv(department)]
     , actual [8,department] = sum(actual)[rep_line_id between 5 and 7, cv(department)]
     , budget [8,department] = sum(budget)[rep_line_id between 5 and 7, cv(department)]
     , actual [9,department] = actual[4,cv(department)] - actual [8,cv(department)]
     , budget [9,department] = budget[4,cv(department)] - budget [8,cv(department)]
     , rep_line_item [for rep_line_id from 1 to 13 increment 1,'All Departments'] = rep_line_item[cv(rep_line_id),'Retail']
     , actual[rep_line_id between 1 and 9,'All Departments'] = sum(actual)[cv(),department in ('Direct','Retail','Internet')]
     , budget[rep_line_id between 1 and 9,'All Departments'] = sum(budget)[cv(),department in ('Direct','Retail','Internet')]
     , actual [10,department] = trunc(actual[2,cv(department)] / actual[1,cv(department)],2)
     , budget [10,department] = trunc(budget[2,cv(department)] / budget[1,cv(department)],2)
     , actual [11,department] = trunc(actual[5,cv(department)] / actual[1,cv(department)],2)
     , budget [11,department] = trunc(budget[5,cv(department)] / budget[1,cv(department)],2)
     , actual [12,department] = trunc(actual[5,cv(department)] / actual[1,cv(department)],2)
     , budget [12,department] = trunc(budget[8,cv(department)] / budget[1,cv(department)],2)
     , actual [13,department] = trunc(actual[9,cv(department)] / actual[1,cv(department)],2)
     , budget [13,department] = trunc(budget[9,cv(department)] / budget[1,cv(department)],2)
     , variance [ANY,ANY] = actual[cv(rep_line_id),cv(department)] - budget[cv(rep_line_id),cv(department)]
     )

pause
/
set echo off
drop table financial_statement purge
/
