set echo on
clear screen
remark
remark  fib(0) = 0
remark  fib(1) = 1
remark  fib(n+2) = fib(n+1) + fib(n), for all natural numbers n
remark
select fib
  from dual
 model
       dimension by (0 i)
       measures (0 fib)
       ( fib[1] = 1
       , fib[for i from 2 to 20 increment 1] = fib[cv()-1] + fib[cv()-2]
       )
/
pause
create table emp_scores
as
select empno
     , round(dbms_random.value(1,3)) score
  from emp
union
select empno
     , round(dbms_random.value(4,6))
  from emp
/
remark
remark  Example from Anthony Molinaro
remark  http://www.oreillynet.com/pub/a/network/2004/08/10/MODELclause.html?page=2
remark
select *
  from emp_scores
 order by empno
     , score
/
pause
select empno
     , s highest_score
     , list
  from ( select score
              , empno
              , lag(score) over (partition by empno order by score) previous_score
           from emp_scores
       )
 where previous_score is not null
 model
       dimension by (empno)
       measures (score s, previous_score vs, 0 tmp, cast(previous_score||','||score as varchar2(20)) list)
       rules iterate(3)
       ( tmp[any]   = s[cv()]
       , s[any]     = s[cv()] + vs[cv()]
       , vs[any]    = tmp[cv()]
       , list[any] = list[cv()] || ',' || to_char(s[cv()])
       )
 order by s desc
     , empno
/
pause
clear screen
remark
remark  A little improvement
remark
select empno
     , max_score highest_score
     , list
  from ( select empno
              , min(score) min_score
              , max(score) max_score
           from emp_scores
          group by empno
       )
 model
       partition by (empno)
       dimension by (1 i)
       measures (min_score, max_score, 0 tmp, to_char(min_score) || ',' || to_char(max_score) as list)
       rules iterate (3)
       ( tmp[1] = max_score[1]
       , max_score[1] = max_score[1] + min_score[1]
       , min_score[1] = tmp[1]
       , list[1] = list[1] || ',' || max_score[1]
       )
 order by max_score desc
     , empno
/
pause
clear screen
select empno
     , max(score) highest_score
     , max(list) keep (dense_rank first order by rn) list
  from ( select empno
              , list
              , score
              , rn
           from emp_scores
          model
                partition by (empno)
                dimension by (row_number() over (partition by empno order by score) - 1 as rn)
                measures (score,cast(score as varchar2(50)) as list)
                rules iterate (4)
                ( score[iteration_number+1]
                  = case
                    when iteration_number > 0 then
                      score[iteration_number] + score[iteration_number-1]
                    else
                      score[iteration_number+1]
                    end
                , list[0] = list[0] || ',' || score[iteration_number+1]
                )
       )
 group by empno
 order by highest_score desc
     , empno
/
set echo off
drop table emp_scores purge
/
