set echo on
clear screen
create table deposits (customer,amount,deposit_date)
as
select 1, 1000, date '2003-01-01' from dual union all
select 1, 200, date '2004-01-01' from dual union all
select 1, 500, date '2005-01-01' from dual union all
select 1, 100, date '2006-01-01' from dual union all
select 1, 800, date '2007-01-01' from dual union all
select 2, 20, date '2003-01-01' from dual union all
select 2, 150, date '2004-01-01' from dual union all
select 2, 60, date '2005-01-01' from dual union all
select 2, 100, date '2006-01-01' from dual union all
select 2, 100, date '2007-01-01' from dual
/
create table interest_rates (startdate,percentage)
as
select date '2003-01-01', 5 from dual union all
select date '2004-01-01', 3.2 from dual union all
select date '2005-01-01', 4.1 from dual union all
select date '2006-01-01', 5.8 from dual union all
select date '2007-01-01', 4.9 from dual
/
select *
  from deposits
 order by customer
     , deposit_date
/
select *
  from interest_rates
 order by startdate
/
pause
select customer
     , amount
     , deposit_date
     , percentage
     , balance balance_at_end_of_year
  from deposits s
     , interest_rates r
 where s.deposit_date = r.startdate
 model
       partition by (s.customer)
       dimension by (s.deposit_date)
       measures (s.amount, r.percentage, 0 balance)
       rules
       ( balance[any] order by deposit_date
         = round
           (   (nvl(balance[add_months(cv(),-12)],0) + amount[cv()])
             * (1 + percentage[cv()]/100)
           , 2
           )
       )
 order by customer
     , deposit_date
/
set echo off
drop table interest_rates purge
/
drop table deposits purge
/
