set echo on
create table booksales
( book    varchar2(17)
, month   date
, country varchar2(3)
, amount  number(6,0)
, primary key (book,month,country)
)
/
insert into booksales values ('The Da Vinci Code',to_date('01032005','ddmmyyyy'),'NED',5);
insert into booksales values ('The Da Vinci Code',to_date('01042005','ddmmyyyy'),'NED',8);
insert into booksales values ('The Da Vinci Code',to_date('01052005','ddmmyyyy'),'NED',3);
insert into booksales values ('The Da Vinci Code',to_date('01072005','ddmmyyyy'),'NED',2);
insert into booksales values ('The Da Vinci Code',to_date('01102005','ddmmyyyy'),'NED',1);
insert into booksales values ('The Da Vinci Code',to_date('01022005','ddmmyyyy'),'GBR',15);
insert into booksales values ('The Da Vinci Code',to_date('01032005','ddmmyyyy'),'GBR',33);
insert into booksales values ('The Da Vinci Code',to_date('01042005','ddmmyyyy'),'GBR',47);
insert into booksales values ('The Da Vinci Code',to_date('01052005','ddmmyyyy'),'GBR',44);
insert into booksales values ('The Da Vinci Code',to_date('01062005','ddmmyyyy'),'GBR',11);
insert into booksales values ('The Da Vinci Code',to_date('01082005','ddmmyyyy'),'GBR',2);
insert into booksales values ('The Da Vinci Code',to_date('01052005','ddmmyyyy'),'FRA',2);
insert into booksales values ('The Da Vinci Code',to_date('01082005','ddmmyyyy'),'FRA',3);
insert into booksales values ('The Da Vinci Code',to_date('01012006','ddmmyyyy'),'FRA',4);
insert into booksales values ('Lord Of The Rings',to_date('01012005','ddmmyyyy'),'NED',102);
insert into booksales values ('Lord Of The Rings',to_date('01022005','ddmmyyyy'),'NED',55);
insert into booksales values ('Lord Of The Rings',to_date('01032005','ddmmyyyy'),'NED',68);
insert into booksales values ('Lord Of The Rings',to_date('01042005','ddmmyyyy'),'NED',42);
insert into booksales values ('Lord Of The Rings',to_date('01052005','ddmmyyyy'),'NED',87);
insert into booksales values ('Lord Of The Rings',to_date('01062005','ddmmyyyy'),'NED',40);
insert into booksales values ('Lord Of The Rings',to_date('01072005','ddmmyyyy'),'NED',31);
insert into booksales values ('Lord Of The Rings',to_date('01082005','ddmmyyyy'),'NED',26);
insert into booksales values ('Lord Of The Rings',to_date('01092005','ddmmyyyy'),'NED',22);
insert into booksales values ('Lord Of The Rings',to_date('01102005','ddmmyyyy'),'NED',23);
insert into booksales values ('Lord Of The Rings',to_date('01112005','ddmmyyyy'),'NED',88);
insert into booksales values ('Lord Of The Rings',to_date('01122005','ddmmyyyy'),'NED',143);
insert into booksales values ('Lord Of The Rings',to_date('01012006','ddmmyyyy'),'NED',31);
insert into booksales values ('Lord Of The Rings',to_date('01022006','ddmmyyyy'),'NED',18);
insert into booksales values ('Lord Of The Rings',to_date('01032006','ddmmyyyy'),'NED',15);
insert into booksales values ('Lord Of The Rings',to_date('01042006','ddmmyyyy'),'NED',11);
insert into booksales values ('Lord Of The Rings',to_date('01052006','ddmmyyyy'),'NED',17);
insert into booksales values ('Lord Of The Rings',to_date('01062006','ddmmyyyy'),'NED',9);
insert into booksales values ('Lord Of The Rings',to_date('01072006','ddmmyyyy'),'NED',12);
insert into booksales values ('Lord Of The Rings',to_date('01082006','ddmmyyyy'),'NED',20);
insert into booksales values ('Lord Of The Rings',to_date('01092006','ddmmyyyy'),'NED',4);
insert into booksales values ('Lord Of The Rings',to_date('01102006','ddmmyyyy'),'NED',5);
insert into booksales values ('Lord Of The Rings',to_date('01112006','ddmmyyyy'),'NED',1);
insert into booksales values ('Lord Of The Rings',to_date('01122006','ddmmyyyy'),'NED',1);
exec dbms_stats.gather_table_stats(user,'booksales')
alter session set nls_date_format = 'mm-yyyy';
select *
  from booksales
 order by book
     , month
/
pause
clear screen
set autotrace on explain
remark
remark    ORDERED FAST
remark
select book
     , month
     , country
     , amount
  from booksales
 model
       return updated rows
       partition by (book,country)
       dimension by (month)
       measures (amount)
       rules
       ( amount[to_date('012007','mmyyyy')] = avg(amount)[any]
       , amount[to_date('022007','mmyyyy')] = amount[to_date('012007','mmyyyy')] * 2
       )
 order by book
     , month
/
pause
remark
remark    ORDERED
remark
select book
     , month
     , country
     , amount
  from booksales
 model
       return updated rows
       partition by (book,country)
       dimension by (month)
       measures (amount)
       rules
       ( amount[to_date('012007','mmyyyy')] = avg(amount)[any]
       , amount[month between to_date('072005','mmyyyy') and to_date('102005','mmyyyy')] = amount[to_date('012007','mmyyyy')] * 2
       )
 order by book
     , month
/
pause
remark
remark    ACYCLIC FAST
remark
select book
     , month
     , country
     , amount
  from booksales
 model
       return updated rows
       partition by (book,country)
       dimension by (month)
       measures (amount)
       rules automatic order
       ( amount[to_date('012007','mmyyyy')] = amount[to_date('022007','mmyyyy')] * 2
       , amount[to_date('022007','mmyyyy')] = 500
       )
 order by book
     , month
/
pause
remark
remark    ACYCLIC, according to the documentation
remark    but CYCLIC
remark
select book
     , month
     , country
     , amount
  from booksales
 model
       return updated rows
       partition by (book,country)
       dimension by (month)
       measures (amount)
       rules automatic order
       ( amount[to_date('012007','mmyyyy')] = percentile_disc(0.5) within group (order by null)[any]
       , amount[to_date('022007','mmyyyy')] = 500
       )
 order by book
     , month
/
pause
/*
remark
remark    CYCLIC
remark
select book
     , month
     , country
     , amount
  from booksales
 model
       return updated rows
       partition by (book,country)
       dimension by (month)
       measures (amount)
       rules automatic order
       ( amount[to_date('022007','mmyyyy')] = amount[(to_date('012007','mmyyyy'))] * 2
       , amount[to_date('012007','mmyyyy')] = percentile_disc(0.5) within group (order by amount)[any]
       )
 order by book
     , month
/
*/
set autotrace off
set echo off
alter session set nls_date_format = 'dd-mm-yyyy hh24:mi:ss'
/
drop table booksales purge
/
