set echo on
clear screen
create table die (face_id,face_value,probability)
as
select 1, 1, 1/4 from dual union all
select 2, 3, 1/4 from dual union all
select 3, 4, 1/4 from dual union all
select 4, 5, 1/12 from dual union all
select 5, 6, 1/12 from dual union all
select 6, 8, 1/12 from dual
/
select * from die order by face_id
/
var N number
exec :N := 2
pause
 select level l
      , cnt
   from (select count(*) cnt from die)
connect by level <= power(cnt,:N)
/
pause
select rn
     , sum_value
     , prob
  from ( select level l
              , cnt
           from (select count(*) cnt from die)
        connect by level <= power(cnt,:N)
       )
 model
       reference r on (select face_id, face_value, probability from die)
         dimension by (face_id)
         measures (face_value,probability) 
       main m
         partition by (l rn, cnt)
         dimension by (0 i)
         measures (0 die_face_id, 0 sum_value, 1 prob, l remainder)
       rules iterate (1000) until (iteration_number + 1 = :N)
       ( die_face_id [0] = 1 + mod(remainder[0]-1,cv(cnt))
       , remainder[0]    = ceil((remainder[0] - die_face_id[0] + 1) / cv(cnt))
       , sum_value[0]    = sum_value[0] + face_value[die_face_id[0]]
       , prob[0]         = prob[0] * probability[die_face_id[0]]
       )
 order by rn
/
pause
select sum_value "Sum"
     , sum(prob) "Probability"
  from ( select sum_value
              , prob
           from ( select level l
                       , cnt
                    from (select count(*) cnt from die)
                 connect by level <= power(cnt,:N)
                )
          model
                reference r on (select face_id, face_value, probability from die)
                  dimension by (face_id)
                  measures (face_value,probability) 
                main m
                  partition by (l rn, cnt)
                  dimension by (0 i)
                  measures (0 die_face_id, 0 sum_value, 1 prob, l remainder)
                rules iterate (1000) until (iteration_number + 1 = :N)
                ( die_face_id [0] = 1 + mod(remainder[0]-1,cv(cnt))
                , remainder[0]    = ceil((remainder[0] - die_face_id[0] + 1) / cv(cnt))
                , sum_value[0]    = sum_value[0] + face_value[die_face_id[0]]
                , prob[0]         = prob[0] * probability[die_face_id[0]]
                )
       ) 
 group by rollup(sum_value)
 order by sum_value
/
pause
update die
   set probability = 1/6
     , face_value = face_id
/
select * from die
/
exec :N := 3
pause
select sum_value "Sum"
     , sum(prob) "Probability"
  from ( select sum_value
              , prob
           from ( select level l
                       , cnt
                    from (select count(*) cnt from die)
                 connect by level <= power(cnt,:N)
                )
          model
                reference r on (select face_id, face_value, probability from die)
                  dimension by (face_id)
                  measures (face_value,probability) 
                main m
                  partition by (l rn, cnt)
                  dimension by (0 i)
                  measures (0 die_face_id, 0 sum_value, 1 prob, l remainder)
                rules iterate (1000) until (iteration_number + 1 = :N)
                ( die_face_id [0] = 1 + mod(remainder[0]-1,cv(cnt))
                , remainder[0]    = ceil((remainder[0] - die_face_id[0] + 1) / cv(cnt))
                , sum_value[0]    = sum_value[0] + face_value[die_face_id[0]]
                , prob[0]         = prob[0] * probability[die_face_id[0]]
                )
       ) 
 group by rollup(sum_value)
 order by sum_value
/
set echo off
drop table die purge
/
