set echo on
column product format a7
clear screen
create table sales (product,month,amount)
as
select 'A', date '2009-01-01', 10 from dual union all
select 'A', date '2009-02-01', 15 from dual union all
select 'A', date '2009-03-01', 17 from dual union all
select 'A', date '2009-04-01', 20 from dual union all
select 'A', date '2009-05-01', 22 from dual union all
select 'A', date '2009-06-01', 20 from dual union all
select 'A', date '2009-07-01', 25 from dual union all
select 'A', date '2009-08-01', 27 from dual union all
select 'A', date '2009-09-01', 30 from dual union all
select 'A', date '2009-10-01', 35 from dual union all
select 'A', date '2009-11-01', 37 from dual union all
select 'A', date '2009-12-01', 40 from dual union all
select 'B', date '2009-01-01', 0 from dual union all
select 'B', date '2009-02-01', 50 from dual union all
select 'B', date '2009-03-01', 10 from dual union all
select 'B', date '2009-04-01', 40 from dual union all
select 'B', date '2009-05-01', 15 from dual union all
select 'B', date '2009-06-01', 35 from dual union all
select 'B', date '2009-07-01', 30 from dual union all
select 'B', date '2009-08-01', 30 from dual union all
select 'B', date '2009-09-01', 20 from dual union all
select 'B', date '2009-10-01', 20 from dual union all
select 'B', date '2009-11-01', 20 from dual union all
select 'B', date '2009-12-01', 20 from dual
/
select *
  from sales
 order by product
     , month
/
pause
select product
     , month
     , amount
     , round(ema,3) "Exponential Moving Average"
  from sales
 model
       partition by (product)
       dimension by (month)
       measures (amount,0 ema)
       ( ema[any] order by month
         = nvl2
           ( ema[add_months(cv(),-1)]
           , ( .5 * (amount[cv()] - ema[add_months(cv(),-1)])) + ema[add_months(cv(),-1)]
           , amount[cv()]
           )
       )
 order by product
     , month
/
set echo off
drop table sales purge
/
