set echo on
clear screen
create table t (text varchar2(33))
/
insert into t values ('Oracle University SQL Masterclass')
/
commit
/
remark
remark  INSTR(string,substring,position,occurrence)
remark
select text
     , instr(text,'s')      i0
     , instr(text,'s',1,1)  i1
     , instr(text,'s',1,2)  i2
     , instr(text,'s',1,3)  i3
     , instr(text,'s',1,4)  i4
     , instr(text,'s',-1,1) i5
     , instr(text,'s',-1,2) i6
     , instr(text,'s',-1,3) i7
     , instr(text,'s',-1,4) i8
  from t
/
pause
remark
remark  REGEXP_INSTR(source_char,pattern,position,occurrence,return_opt,match_param,subexpr)
remark
select text
     , regexp_instr(text,'s')      i0
     , regexp_instr(text,'s',1,1)  i1
     , regexp_instr(text,'s',1,2)  i2
     , regexp_instr(text,'s',1,3)  i3
     , regexp_instr(text,'s',1,4)  i4
  from t
/
pause
select text
     , regexp_instr(text,'s',-1,1) i5
     , regexp_instr(text,'s',-1,2) i6
     , regexp_instr(text,'s',-1,3) i7
     , regexp_instr(text,'s',-1,4) i8
  from t
/
pause
clear screen
remark
remark  5th parameter: return_opt
remark
select text
     , regexp_instr(text,'s',1,1,0) i1
     , regexp_instr(text,'s',1,2,0) i2
     , regexp_instr(text,'s',1,3,0) i3
     , regexp_instr(text,'s',1,4,0) i4
  from t
/
pause
select text
     , regexp_instr(text,'s',1,1,1) i1
     , regexp_instr(text,'s',1,2,1) i2
     , regexp_instr(text,'s',1,3,1) i3
     , regexp_instr(text,'s',1,4,1) i4
  from t
/
pause
select text
     , regexp_instr(text,'Univers',1,1,0) i1
     , regexp_instr(text,'Univers',1,1,1) i2
  from t
/
pause
clear screen
remark
remark  6th parameter: match_param
remark
remark  'c': case sensitive
remark
select text
     , regexp_instr(text,'s',1,1,0,'c') i1
     , regexp_instr(text,'s',1,2,0,'c') i2
     , regexp_instr(text,'s',1,3,0,'c') i3
     , regexp_instr(text,'s',1,4,0,'c') i4
     , regexp_instr(text,'s',1,5,0,'c') i5
  from t
/
pause
remark
remark  'i': case insensitive
remark
select text
     , regexp_instr(text,'s',1,1,0,'i') i1
     , regexp_instr(text,'s',1,2,0,'i') i2
     , regexp_instr(text,'s',1,3,0,'i') i3
     , regexp_instr(text,'s',1,4,0,'i') i4
     , regexp_instr(text,'s',1,5,0,'i') i5
  from t
/
pause
remark
remark  'x': ignores whitespace characters
remark
select text
     , regexp_instr(text,'L M',1,1,0)     i1
     , regexp_instr(text,'L M',1,1,0,'x') i2
     , regexp_instr(text,'LM',1,1,0,'x')  i3
  from t
/
pause
remark
remark  'm': multiline mode; treats the source string as multiple lines
remark
insert into t values ('Multiple
Lines')
/
select text
     , regexp_instr(text,'$',1,1,0)     i1
     , regexp_instr(text,'$',1,2,0)     i2
     , regexp_instr(text,'$',1,1,0,'m') i3
     , regexp_instr(text,'$',1,2,0,'m') i4
  from t
/
pause
remark
remark  'n': allows the period (.), which is the match-any-character character, to match the newline character
remark
select text
     , regexp_instr(text,'.L',1,1,0)     i1
     , regexp_instr(text,'.L',1,1,0,'n') i2
  from t
/
pause
clear screen
rollback
/
remark
remark  7th parameter: subexpr
remark
select text
     , regexp_instr(text,'Univers',1,1,0) i1
     , regexp_instr(text,'Univers',1,1,1) i2
  from t
/
pause
select text
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,0)      i1_0
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,1)      i1_1
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,0,'',0) i2_0
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,1,'',0) i2_1
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,0,'',1) i3_0
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,1,'',1) i3_1
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,0,'',2) i4_0
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,1,'',2) i4_1
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,0,'',3) i5_0
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,1,'',3) i5_1
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,0,'',4) i6_0
     , regexp_instr(text,'U((n)iv)e(rs)',1,1,1,'',4) i6_1
  from t
/
set echo off
drop table t purge
/
