column acres format a20
create table michigan_parks
( park_name   varchar2(50) not null
, description varchar2(4000) not null
)
/
insert into michigan_parks (park_name, description)
values ('Mackinac Island State Park', 'Michigan''s first state park encompasses approximately 1800 acres of Mackinac Island. The centerpiece is Fort Mackinac, built in 1780 by the British to protect the Great Lakes Fur Trade. For information by phone, dial 800-44-PARKS or 517-373-1214.');
insert into michigan_parks (park_name, description)
values ('Fort Wilkens State Park', 'Located almost at the very tip of the Keewenaw Peninsula.' || chr(10) || '' || chr(10) || 'Fort Wilkens is a 217-acre restored army fort built during the coper rush.' || chr(10) || 'Camping is available. For the modern campground, phone (800) 447-2757. For group camping, phone 906.289.4215. For information on canoe, kayak, and other boat rentals, call the concession office at (906) 289-4210.');
insert into michigan_parks (park_name, description)
values ('Muskallonge Mountains State Park', 'Michigan''s largest state park consists of some 60,000 acres of mostly virgin timber. Over 90 miles of trails are available to backpackers and hikers. Downhill skiing is available in winter. Rustic cabins are available. To reserve a cabin, call (906) 885-5275.');
set echo on
select *
  from michigan_parks
/
pause
select park_name
     , regexp_substr(description,'[^ ]+[- ]acres?') acres 
  from michigan_parks
 where regexp_like(description,'[^ ]+[- ]acres?')
/
pause
set echo off
drop table michigan_parks purge
/  
set echo on
clear screen
create table relations (name,address)
as
select 'Oracle Netherlands', 'Hertogswetering 163-167 3543 AS Utrecht' from dual union all
select 'Prime Minister''s Office', '10 Downing Street, London, SW1A 2AA' from dual union all
select 'Ciber Netherlands', 'Meerkollaan 15, 5613BS, Eindhoven' from dual
/
select *
  from relations
/
pause
select name
     , regexp_substr
       ( address
       , '[[:digit:]]{4} ?[[:alpha:]]{2}'
       )
  from relations
/
set echo off
drop table relations purge
/
