column x format a10
column y format a10
set echo on
clear screen
select regexp_substr
       ( 'this766is766a766delimited766string'
       , '766'
       )
  from dual
/
pause
select regexp_substr
       ( 'this766is766a766delimited766string'
       , '[^(766)]+'
       , 1
       , 4
       )
  from dual
/
pause
with t as
( select 'ONE,TWO,THREE,FOUR,FIVE,SIX,SEVEN,EIGHT,NINE,TEN' text
    from dual
)
select text
     , regexp_substr(text,'[^,]+',1,3) x
     , regexp_substr(text,'[^,]+',1,8) y
  from t
/
pause
with t as
( select 'ONE,TWO,THREE,FOUR,FIVE,SIX,SEVEN,EIGHT,NINE,TEN' text
    from dual
)
select text
     , substr
       ( text
       , instr(text,',',1,2) + 1
       , instr(text,',',1,3) - instr(text,',',1,2) - 1
       ) x
     , substr
       ( text
       , instr(text,',',1,7) + 1
       , instr(text,',',1,8) - instr(text,',',1,7) - 1
       ) y
  from t
/
pause
clear screen
select systimestamp
  from dual
/
 select substr
        ( text
        , instr(text,',',1,7) + 1
        , instr(text,',',1,8) - instr(text,',',1,7) - 1
        ) y
   from dual
connect by level <= 100000

set termout off
/
set termout on
select systimestamp
  from dual
/
 select regexp_substr('ONE,TWO,THREE,FOUR,FIVE,SIX,SEVEN,EIGHT,NINE,TEN','[^,]+',1,8) y
   from dual
connect by level <= 100000

set termout off
/
set termout on
select systimestamp
  from dual
/
pause
set timing on
declare
  c_text varchar2(60) := 'ONE,TWO,THREE,FOUR,FIVE,SIX,SEVEN,EIGHT,NINE,TEN';
  l_text varchar2(60);
  l      varchar2(11);
begin
  for i in 1..100000
  loop
    l_text := c_text || to_char(i)
    ;
    l := substr
    ( l_text
    , instr(l_text,',',1,7) + 1
    , instr(l_text,',',1,8) - instr(l_text,',',1,7) - 1
    );
  end loop;
end;
/
declare
  c_text varchar2(60) := 'ONE,TWO,THREE,FOUR,FIVE,SIX,SEVEN,EIGHT,NINE,TEN';
  l_text varchar2(60);
  l      varchar2(11);
begin
  for i in 1..100000
  loop
    l_text := c_text || to_char(i)
    ;
    l := regexp_substr(l_text,'[^,]+',1,8);
  end loop;
end;
/
set timing off
pause
clear screen
select regexp_substr
       ( 'Sometimes you type in in double words in a piece of text, that are hard to find.'
       , '([[:alnum:]]+)([[:space:]]+)\1'
       )
  from dual
/
pause
select regexp_substr
       ( 'Sometimes you type in in double words in a piece of text, that are hard to find.'
       , '([[:alnum:]]+) +\1'
       )
  from dual
/
pause
select regexp_replace
       ( 'Sometimes you type in in double words in a piece of text, that are hard to find.'
       , '(.*)([[:alnum:]]+) +\2(.*)'
       , '\1\2\3'
       )
  from dual
/
pause
clear screen
select regexp_substr
       ( replace
         ( 'De vriesstraat 456bis, 7678 GH Leeuwarden, bill number 788387377 and now follows the number which we want to extract 1 9 7 5 6 455 6with some whitespace in between.'
         ,' '
         )
       , '[[:digit:]]{9}'
       , 1
       , 2
       ) 
  from dual
/
set echo off
