set echo on
column s1 format a20
column s2 format a20
column s3 format a20
column s4 format a20
column s5 format a16
create table t (text varchar2(33))
/
insert into t values ('Oracle University SQL Masterclass')
/
commit
/
remark
remark  SUBSTR(char,position,substring_length)
remark
select text
     , substr(text,23)   s1
     , substr(text,23,6) s2
     , substr(text,-5)   s3
  from t
/
pause
remark
remark  REGEXP_SUBSTR(source_char,pattern,position,occurrence,match_param,subexpr)
remark
select text
     , regexp_substr(text,23)   s1
     , regexp_substr(text,23,6) s2
     , regexp_substr(text,-5)   s3
  from t
/
pause
select text
     , regexp_substr(text,'s',1,1) s1
     , regexp_substr(text,'s',1,2) s2
     , regexp_substr(text,'s',1,3) s3
     , regexp_substr(text,'s',1,4) s4
     , regexp_substr(text,'s',1,5) s5
  from t
/
pause
remark
remark  6th parameter: match_param
remark
remark  'c': case sensitive
remark
select text
     , regexp_substr(text,'s',1,1,'c') s1
     , regexp_substr(text,'s',1,2,'c') s2
     , regexp_substr(text,'s',1,3,'c') s3
     , regexp_substr(text,'s',1,4,'c') s4
     , regexp_substr(text,'s',1,5,'c') s5
  from t
/
pause
remark
remark  'i': case insensitive
remark
select text
     , regexp_substr(text,'s',1,1,'i') s1
     , regexp_substr(text,'s',1,2,'i') s2
     , regexp_substr(text,'s',1,3,'i') s3
     , regexp_substr(text,'s',1,4,'i') s4
     , regexp_substr(text,'s',1,5,'i') s5
  from t
/
pause
remark
remark  'x': ignores whitespace characters
remark
select text
     , regexp_substr(text,'L M',1,1)     s1
     , regexp_substr(text,'L M',1,1,'x') s2
     , regexp_substr(text,'LM',1,1,'x')  s3
  from t
/
pause
remark
remark  'm': multiline mode; treats the source string as multiple lines
remark
insert into t values ('Multiple
Lines')
/
select text
     , regexp_substr(text,'e$',1,1)     s1
     , regexp_substr(text,'e$',1,2)     s2
     , regexp_substr(text,'e$',1,1,'m') s3
     , regexp_substr(text,'e$',1,2,'m') s4
  from t
/
pause
remark
remark  'n': allows the period (.), which is the match-any-character character, to match the newline character
remark
select text
     , regexp_substr(text,'.L',1,1)     s1
     , regexp_substr(text,'.L',1,1,'n') s2
  from t
/
pause
rollback
/
remark
remark  7th parameter: subexpr
remark
select text
     , regexp_substr(text,'U((n)iv)e(rs)',1,1)      s1
     , regexp_substr(text,'U((n)iv)e(rs)',1,1,'',0) s2
     , regexp_substr(text,'U((n)iv)e(rs)',1,1,'',1) s3
     , regexp_substr(text,'U((n)iv)e(rs)',1,1,'',2) s4
     , regexp_substr(text,'U((n)iv)e(rs)',1,1,'',3) s5
     , regexp_substr(text,'U((n)iv)e(rs)',1,1,'',4) s6
  from t
/
set echo off
drop table t purge
/
