set echo on
column ename format a20
column scbp format a30
clear screen
 select ename
      , empno
      , mgr
      , deptno
      , sys_connect_by_path(ename,'/') scbp
   from emp
connect by mgr = prior empno
  start with mgr is null
  order siblings by deptno
/
pause
clear screen
with emps (ename,empno,mgr,deptno,scbp) as
( select ename
       , empno
       , mgr
       , deptno
       , ename
    from emp
   where mgr is null
   union all
  select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
       , emps.scbp || '/' || emp.ename
    from emp
         join emps on (emp.mgr = emps.empno)
) search depth first by deptno set a
select ename
     , empno
     , mgr
     , deptno
     , scbp
  from emps
 order by a
/
set echo off
