set echo on
column ename format a20
column cbr format a20
clear screen
update emp
   set mgr = 7566
 where ename = 'KING'
/
 select ename
      , empno
      , mgr
      , deptno
   from emp
connect by mgr = prior empno
  start with ename = 'KING'
  order siblings by deptno, ename
/
pause
clear screen
 select ename
      , empno
      , mgr
      , deptno
      , connect_by_iscycle
   from emp
connect by nocycle mgr = prior empno
  start with ename = 'KING'
  order siblings by deptno, ename
/
pause
clear screen
with emps (ename,empno,mgr,deptno,lvl) as
( select ename
       , empno
       , mgr
       , deptno
       , 1
    from emp
   where ename = 'KING'
   union all
  select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
       , emps.lvl + 1
    from emp
         join emps on (emp.mgr = emps.empno)
) search depth first by deptno set a
  cycle empno set is_cycle to '1' default '0'
select lpad(' ', 2 * lvl - 2, ' ') || ename as ename
     , empno
     , mgr
     , deptno
     , lvl
     , is_cycle
  from emps
 order by a
     , ename
/
rollback
/
pause
clear screen
set echo off
