set echo on
column ename format a20
clear screen
 select ename
      , empno
      , mgr
      , deptno
   from emp
connect by mgr = prior empno
  start with mgr is null
  order siblings by deptno
/
pause
clear screen
with emps (ename,empno,mgr,deptno) as
( select ename
       , empno
       , mgr
       , deptno
    from emp
   where mgr is null
   union all
  select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
    from emp
         join emps on (emp.mgr = emps.empno)
) search depth first by deptno set a
select ename
     , empno
     , mgr
     , deptno
  from emps
 order by a
/
pause
select ename
     , empno
     , mgr
     , deptno
  from emp
 where mgr is null
/
pause
with emp_start as
( select ename
       , empno
       , mgr
       , deptno
    from emp
   where mgr is null
)
, emp2 as
( select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
    from emp
         join emp_start on (emp.mgr = emp_start.empno)
)
select *
  from emp_start
 union all
select *
  from emp2
/
pause
with emp_start as
( select ename
       , empno
       , mgr
       , deptno
    from emp
   where mgr is null
)
, emp2 as
( select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
    from emp
         join emp_start on (emp.mgr = emp_start.empno)
)
, emp3 as
( select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
    from emp
         join emp2 on (emp.mgr = emp2.empno)
)
select *
  from emp_start
 union all
select *
  from emp2
 union all
select *
  from emp3
/
pause
with emp_start as
( select ename
       , empno
       , mgr
       , deptno
    from emp
   where mgr is null
)
, emp2 as
( select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
    from emp
         join emp_start on (emp.mgr = emp_start.empno)
)
, emp3 as
( select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
    from emp
         join emp2 on (emp.mgr = emp2.empno)
)
, emp4 as
( select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
    from emp
         join emp3 on (emp.mgr = emp3.empno)
)
select *
  from emp_start
 union all
select *
  from emp2
 union all
select *
  from emp3
 union all
select *
  from emp4
/
set echo off
