set echo on
column name format a10
column job format a10
column department format a10
clear screen
create table xml_to_process (x xmltype)
/
insert into xml_to_process
values (xmltype(
'<Employees>
  <Employee>
    <Name>ADAMS</Name>
    <Job>CLERK</Job>
    <Department>20</Department>
  </Employee>
  <Employee>
    <Name>ALLEN</Name>
    <Job>SALESMAN</Job>
    <Department>30</Department>
  </Employee>
  <Employee>
    <Name>BLAKE</Name>
    <Job>MANAGER</Job>
    <Department>30</Department>
  </Employee>
  <Employee>
    <Name>CLARK</Name>
    <Job>MANAGER</Job>
    <Department>10</Department>
  </Employee>
  <Employee>
    <Name>FORD</Name>
    <Job>ANALYST</Job>
    <Department>20</Department>
  </Employee>
</Employees>')
)
/
pause
select x
  from xml_to_process
/
pause
select p.*
  from xml_to_process xtp
     , xmltable
       ( 'Employees'
         passing xtp.x
       ) p
/
pause
select p.*
  from xml_to_process xtp
     , xmltable
       ( 'Employees'
         passing xtp.x
         columns name       varchar2(10) path 'Employee/Name'
               , job        varchar2(10) path 'Employee/Job'
               , department varchar2(10) path 'Employee/Department'
       ) p
/
pause
select p.*
  from xml_to_process xtp
     , xmltable
       ( 'Employees/Employee'
         passing xtp.x
         columns name       varchar2(10) path 'Name'
               , job        varchar2(10) path 'Job'
               , department varchar2(10) path 'Department'
       ) p
/
set echo off
drop table xml_to_process purge
/
